/* Written by Dmitrij Schlesinger (2012),
 * www.inf.tu-dresden.de/~ds24/rtsegm/rtsegm.html
 *
 * See paper "A Real-time MRF Based Approach for Binary Segmentation"
 * at DAGM-OAGM 2012 Conference for details.
*/

#ifndef __RTSEGM_SHAPE
#define __RTSEGM_SHAPE

#include "ed_thread.h"

// This class implements the shape estimation
class Rtsegm_shape : public ed_thread {
public:
    Rtsegm_shape(int height, int width, double scale, double step);
    ~Rtsegm_shape();

    // thread management
    bool stop_me;
    void run();
    void reset();
    int it_count;

    // auxiliary function to calculate additional unary shape terms
    // used by "Rtsegm_segm"
    void fill();

    // modell data
    int width, height;
    // current segmentation (sampled by "Rtsegm_segm")
    int *lab;
    // the additional unary potentials for the foregroung
    // used by "Rtsegm_segm"
    double *qsh;

    // shape parameters (to be estimated)
    double x0, y0, rx, ry, level;

    // fixed values
    double scale, step;
};

#endif
